// -*- c++ -*-
/* This is a generated file, do not edit.  Generated from macros/basic_signal.h.m4 */

#ifndef SIGCXX_BASIC_SIGNAL_H
#define SIGCXX_BASIC_SIGNAL_H
#include <sigc++/marshal.h>
#include <sigc++/slot.h>

// Qt steals a method name.
#ifdef SIGC_QT
#undef emit
#endif

#ifdef emit
#define SIGC_QT
#undef emit
#endif



#ifdef SIGC_CXX_NAMESPACES
namespace SigC
{
#endif

/****************************************************************
*****  Signals (build by macros)
****************************************************************/

// common part to all signals
class LIBSIGC_API Signal_
  {
    private:
      Signal_(const Signal_&);

    protected:
      typedef ScopeList List;
   
      struct LIBSIGC_API Impl 
        { 
          typedef ScopeList List;
          List incoming_;
          List outgoing_;
          Impl();
          ~Impl();
        };

      Impl *impl;

      SlotData* in_connect();
      SlotData* out_connect(SlotData *s);

      Signal_();
      ~Signal_();

    public:
      bool empty() const;
      void clear();
  };


/****************************************************************
*****  Signal 0
****************************************************************/

template <class R,typename Marsh=Marshal<R> >
  class Signal0:public Signal_
  {
   public:
     typedef Slot0<R>                       InSlotType;
     typedef Slot0<typename Marsh::OutType> OutSlotType;

   private:
#ifdef SIGC_CXX_PARTIAL_SPEC
     typedef typename Marsh::OutType SType;
     typedef R RType;
#else
     typedef Trait<typename Marsh::OutType>::type SType;
     typedef Trait<R>::type RType;
#endif
     typedef typename InSlotType::Callback Callback;
     typedef Signal0<R,Marsh> Self;
     typedef CallDataObj2<typename OutSlotType::Func,Self> CallData;

     static SType callback(void* d)
       {
        CallData* data=(CallData*)d;
        return data->obj->emit();
       }

   public:
     OutSlotType slot()
       {
        SlotData* tmp=in_connect();
        CallData &data=reinterpret_cast<CallData&>(tmp->data_);
        data.callback=(typename OutSlotType::Func)callback;
        data.obj=this;
        return tmp;
       }

     Connection connect(const InSlotType &s)
       {
        return out_connect(s.data());
       }

     SType emit();
     SType operator()()
       {return emit();}

     Signal0() {}
     Signal0(const InSlotType &s) {connect(s);}
     ~Signal0() {}
  };


// emit
template <class R,class Marsh>
typename  Signal0<R,Marsh>::SType Signal0<R,Marsh>::
  emit()
  {
   if (!impl||impl->outgoing_.empty()) return Marsh::default_value();
   List &out=impl->outgoing_; 
   Marsh rc;
   SlotData *data;
   List::Iterator i=out.begin();
   while (i!=out.end())
     {
      data=((SlotDependent*)(i.node()))->parent();
      ++i;
      Callback& s=(Callback&)(data->callback());
      if (rc.marshal(s.call())) return rc.value();
     } 
   return rc.value();
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class Marsh>
class Signal0<void,Marsh>
  :public Signal_
  {
   public:
     typedef Slot0<void> InSlotType;
     typedef Slot0<void> OutSlotType;
   private:
     typedef InSlotType::Callback Callback;
     typedef Signal0<void,Marsh> Self;
     typedef CallDataObj2<OutSlotType::Func,Self> CallData;

     static void callback(void* d)
       {
        CallData* data=(CallData*)d;
        data->obj->emit();
       }

   public:
     OutSlotType slot()
       {
        SlotData* tmp=in_connect();
        CallData& data=reinterpret_cast<CallData&>(tmp->data_);
        data.callback=callback;
        data.obj=this;
        return tmp;
       }

     Connection connect(const InSlotType &s)
       {
        return out_connect(s.data());
       }

     void emit();
     void operator()()
       {emit();}

     Signal0() {}
     Signal0(const InSlotType &s) {connect(s);}
     ~Signal0() {}
  };


// emit
template <class Marsh>
void Signal0<void,Marsh>::
  emit()
  {
   if (!impl||impl->outgoing_.empty()) return;
   List &out=impl->outgoing_; 
   SlotData *data;
   List::Iterator i=out.begin();
   while (i!=out.end())
     {
      data=((SlotDependent*)(i.node()))->parent();
      ++i;
      Callback& s=(Callback&)(data->callback());
      s.call();
     }
  }

#endif


/****************************************************************
*****  Signal 1
****************************************************************/

template <class R,class P1,typename Marsh=Marshal<R> >
  class Signal1:public Signal_
  {
   public:
     typedef Slot1<R,P1>                       InSlotType;
     typedef Slot1<typename Marsh::OutType,P1> OutSlotType;

   private:
#ifdef SIGC_CXX_PARTIAL_SPEC
     typedef typename Marsh::OutType SType;
     typedef R RType;
#else
     typedef Trait<typename Marsh::OutType>::type SType;
     typedef Trait<R>::type RType;
#endif
     typedef typename InSlotType::Callback Callback;
     typedef Signal1<R,P1,Marsh> Self;
     typedef CallDataObj2<typename OutSlotType::Func,Self> CallData;

     static SType callback(void* d,P1 p1)
       {
        CallData* data=(CallData*)d;
        return data->obj->emit(p1);
       }

   public:
     OutSlotType slot()
       {
        SlotData* tmp=in_connect();
        CallData &data=reinterpret_cast<CallData&>(tmp->data_);
        data.callback=(typename OutSlotType::Func)callback;
        data.obj=this;
        return tmp;
       }

     Connection connect(const InSlotType &s)
       {
        return out_connect(s.data());
       }

     SType emit(typename Trait<P1>::ref p1);
     SType operator()(typename Trait<P1>::ref p1)
       {return emit(p1);}

     Signal1() {}
     Signal1(const InSlotType &s) {connect(s);}
     ~Signal1() {}
  };


// emit
template <class R,class P1,class Marsh>
typename  Signal1<R,P1,Marsh>::SType Signal1<R,P1,Marsh>::
  emit(typename Trait<P1>::ref p1)
  {
   if (!impl||impl->outgoing_.empty()) return Marsh::default_value();
   List &out=impl->outgoing_; 
   Marsh rc;
   SlotData *data;
   List::Iterator i=out.begin();
   while (i!=out.end())
     {
      data=((SlotDependent*)(i.node()))->parent();
      ++i;
      Callback& s=(Callback&)(data->callback());
      if (rc.marshal(s.call(p1))) return rc.value();
     } 
   return rc.value();
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class Marsh>
class Signal1<void,P1,Marsh>
  :public Signal_
  {
   public:
     typedef Slot1<void,P1> InSlotType;
     typedef Slot1<void,P1> OutSlotType;
   private:
     typedef typename InSlotType::Callback Callback;
     typedef Signal1<void,P1,Marsh> Self;
     typedef CallDataObj2<typename OutSlotType::Func,Self> CallData;

     static void callback(void* d,P1 p1)
       {
        CallData* data=(CallData*)d;
        data->obj->emit(p1);
       }

   public:
     OutSlotType slot()
       {
        SlotData* tmp=in_connect();
        CallData& data=reinterpret_cast<CallData&>(tmp->data_);
        data.callback=callback;
        data.obj=this;
        return tmp;
       }

     Connection connect(const InSlotType &s)
       {
        return out_connect(s.data());
       }

     void emit(typename Trait<P1>::ref p1);
     void operator()(typename Trait<P1>::ref p1)
       {emit(p1);}

     Signal1() {}
     Signal1(const InSlotType &s) {connect(s);}
     ~Signal1() {}
  };


// emit
template <class P1,class Marsh>
void Signal1<void,P1,Marsh>::
  emit(typename Trait<P1>::ref p1)
  {
   if (!impl||impl->outgoing_.empty()) return;
   List &out=impl->outgoing_; 
   SlotData *data;
   List::Iterator i=out.begin();
   while (i!=out.end())
     {
      data=((SlotDependent*)(i.node()))->parent();
      ++i;
      Callback& s=(Callback&)(data->callback());
      s.call(p1);
     }
  }

#endif


/****************************************************************
*****  Signal 2
****************************************************************/

template <class R,class P1,class P2,typename Marsh=Marshal<R> >
  class Signal2:public Signal_
  {
   public:
     typedef Slot2<R,P1,P2>                       InSlotType;
     typedef Slot2<typename Marsh::OutType,P1,P2> OutSlotType;

   private:
#ifdef SIGC_CXX_PARTIAL_SPEC
     typedef typename Marsh::OutType SType;
     typedef R RType;
#else
     typedef Trait<typename Marsh::OutType>::type SType;
     typedef Trait<R>::type RType;
#endif
     typedef typename InSlotType::Callback Callback;
     typedef Signal2<R,P1,P2,Marsh> Self;
     typedef CallDataObj2<typename OutSlotType::Func,Self> CallData;

     static SType callback(void* d,P1 p1,P2 p2)
       {
        CallData* data=(CallData*)d;
        return data->obj->emit(p1,p2);
       }

   public:
     OutSlotType slot()
       {
        SlotData* tmp=in_connect();
        CallData &data=reinterpret_cast<CallData&>(tmp->data_);
        data.callback=(typename OutSlotType::Func)callback;
        data.obj=this;
        return tmp;
       }

     Connection connect(const InSlotType &s)
       {
        return out_connect(s.data());
       }

     SType emit(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2);
     SType operator()(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2)
       {return emit(p1,p2);}

     Signal2() {}
     Signal2(const InSlotType &s) {connect(s);}
     ~Signal2() {}
  };


// emit
template <class R,class P1,class P2,class Marsh>
typename  Signal2<R,P1,P2,Marsh>::SType Signal2<R,P1,P2,Marsh>::
  emit(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2)
  {
   if (!impl||impl->outgoing_.empty()) return Marsh::default_value();
   List &out=impl->outgoing_; 
   Marsh rc;
   SlotData *data;
   List::Iterator i=out.begin();
   while (i!=out.end())
     {
      data=((SlotDependent*)(i.node()))->parent();
      ++i;
      Callback& s=(Callback&)(data->callback());
      if (rc.marshal(s.call(p1,p2))) return rc.value();
     } 
   return rc.value();
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class Marsh>
class Signal2<void,P1,P2,Marsh>
  :public Signal_
  {
   public:
     typedef Slot2<void,P1,P2> InSlotType;
     typedef Slot2<void,P1,P2> OutSlotType;
   private:
     typedef typename InSlotType::Callback Callback;
     typedef Signal2<void,P1,P2,Marsh> Self;
     typedef CallDataObj2<typename OutSlotType::Func,Self> CallData;

     static void callback(void* d,P1 p1,P2 p2)
       {
        CallData* data=(CallData*)d;
        data->obj->emit(p1,p2);
       }

   public:
     OutSlotType slot()
       {
        SlotData* tmp=in_connect();
        CallData& data=reinterpret_cast<CallData&>(tmp->data_);
        data.callback=callback;
        data.obj=this;
        return tmp;
       }

     Connection connect(const InSlotType &s)
       {
        return out_connect(s.data());
       }

     void emit(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2);
     void operator()(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2)
       {emit(p1,p2);}

     Signal2() {}
     Signal2(const InSlotType &s) {connect(s);}
     ~Signal2() {}
  };


// emit
template <class P1,class P2,class Marsh>
void Signal2<void,P1,P2,Marsh>::
  emit(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2)
  {
   if (!impl||impl->outgoing_.empty()) return;
   List &out=impl->outgoing_; 
   SlotData *data;
   List::Iterator i=out.begin();
   while (i!=out.end())
     {
      data=((SlotDependent*)(i.node()))->parent();
      ++i;
      Callback& s=(Callback&)(data->callback());
      s.call(p1,p2);
     }
  }

#endif


/****************************************************************
*****  Signal 3
****************************************************************/

template <class R,class P1,class P2,class P3,typename Marsh=Marshal<R> >
  class Signal3:public Signal_
  {
   public:
     typedef Slot3<R,P1,P2,P3>                       InSlotType;
     typedef Slot3<typename Marsh::OutType,P1,P2,P3> OutSlotType;

   private:
#ifdef SIGC_CXX_PARTIAL_SPEC
     typedef typename Marsh::OutType SType;
     typedef R RType;
#else
     typedef Trait<typename Marsh::OutType>::type SType;
     typedef Trait<R>::type RType;
#endif
     typedef typename InSlotType::Callback Callback;
     typedef Signal3<R,P1,P2,P3,Marsh> Self;
     typedef CallDataObj2<typename OutSlotType::Func,Self> CallData;

     static SType callback(void* d,P1 p1,P2 p2,P3 p3)
       {
        CallData* data=(CallData*)d;
        return data->obj->emit(p1,p2,p3);
       }

   public:
     OutSlotType slot()
       {
        SlotData* tmp=in_connect();
        CallData &data=reinterpret_cast<CallData&>(tmp->data_);
        data.callback=(typename OutSlotType::Func)callback;
        data.obj=this;
        return tmp;
       }

     Connection connect(const InSlotType &s)
       {
        return out_connect(s.data());
       }

     SType emit(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2,typename Trait<P3>::ref p3);
     SType operator()(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2,typename Trait<P3>::ref p3)
       {return emit(p1,p2,p3);}

     Signal3() {}
     Signal3(const InSlotType &s) {connect(s);}
     ~Signal3() {}
  };


// emit
template <class R,class P1,class P2,class P3,class Marsh>
typename  Signal3<R,P1,P2,P3,Marsh>::SType Signal3<R,P1,P2,P3,Marsh>::
  emit(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2,typename Trait<P3>::ref p3)
  {
   if (!impl||impl->outgoing_.empty()) return Marsh::default_value();
   List &out=impl->outgoing_; 
   Marsh rc;
   SlotData *data;
   List::Iterator i=out.begin();
   while (i!=out.end())
     {
      data=((SlotDependent*)(i.node()))->parent();
      ++i;
      Callback& s=(Callback&)(data->callback());
      if (rc.marshal(s.call(p1,p2,p3))) return rc.value();
     } 
   return rc.value();
  }

#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,class P3,class Marsh>
class Signal3<void,P1,P2,P3,Marsh>
  :public Signal_
  {
   public:
     typedef Slot3<void,P1,P2,P3> InSlotType;
     typedef Slot3<void,P1,P2,P3> OutSlotType;
   private:
     typedef typename InSlotType::Callback Callback;
     typedef Signal3<void,P1,P2,P3,Marsh> Self;
     typedef CallDataObj2<typename OutSlotType::Func,Self> CallData;

     static void callback(void* d,P1 p1,P2 p2,P3 p3)
       {
        CallData* data=(CallData*)d;
        data->obj->emit(p1,p2,p3);
       }

   public:
     OutSlotType slot()
       {
        SlotData* tmp=in_connect();
        CallData& data=reinterpret_cast<CallData&>(tmp->data_);
        data.callback=callback;
        data.obj=this;
        return tmp;
       }

     Connection connect(const InSlotType &s)
       {
        return out_connect(s.data());
       }

     void emit(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2,typename Trait<P3>::ref p3);
     void operator()(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2,typename Trait<P3>::ref p3)
       {emit(p1,p2,p3);}

     Signal3() {}
     Signal3(const InSlotType &s) {connect(s);}
     ~Signal3() {}
  };


// emit
template <class P1,class P2,class P3,class Marsh>
void Signal3<void,P1,P2,P3,Marsh>::
  emit(typename Trait<P1>::ref p1,typename Trait<P2>::ref p2,typename Trait<P3>::ref p3)
  {
   if (!impl||impl->outgoing_.empty()) return;
   List &out=impl->outgoing_; 
   SlotData *data;
   List::Iterator i=out.begin();
   while (i!=out.end())
     {
      data=((SlotDependent*)(i.node()))->parent();
      ++i;
      Callback& s=(Callback&)(data->callback());
      s.call(p1,p2,p3);
     }
  }

#endif



#ifdef SIGC_CXX_NAMESPACES
} // namespace
#endif

#ifdef SIGC_QT
#define emit
#endif


#endif // SIGCXX_BASIC_SIGNAL_H

