// -*- c++ -*-
/* This is a generated file, do not edit.  Generated from macros/rettype.h.m4 */

#ifndef SIGCXX_RETTYPE_H
#define SIGCXX_RETTYPE_H

/*
  SigC::rettype
  -------------
  rettype() alters a Slot by changing the return type.

  Only allowed conversions or conversions to void can properly
  be implemented.  The type must always be specified as a
  template parameter. 

  Simple Sample usage:

    int f(int);

    Slot1<void,int>   s1=rettype<void>(slot(&f)); 
    Slot1<float,int>  s2=rettype<float>(slot(&f)); 

*/

#include <sigc++/adaptor.h>

#ifdef SIGC_CXX_NAMESPACES
namespace SigC
{
#endif











/****************************************************************
***** Adaptor Rettype Slot 0
****************************************************************/
template <class R1,
   class R2>
struct AdaptorRettypeSlot0_
  : public AdaptorSlot_
  {
#ifdef SIGC_CXX_PARTIAL_SPEC
   typedef R1 RType;
#else
   typedef typename Trait<R1>::type RType;
#endif
   typedef Slot0<R1> SlotType;
   typedef Slot0<R2> InSlotType;
   typedef AdaptorNode Node;
   typedef CallDataObj2<typename SlotType::Func,Node> CallData;

   static RType callback(void* d)
     {
      CallData* data=(CallData*)d;
      Node* node=data->obj;
      return RType(((typename InSlotType::Callback&)(node->data_))());
     }
   static SlotData* create(SlotData *s)
     {
      SlotData* tmp=(SlotData*)s;
      Node *node=new Node();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.obj=node;
      return tmp;
     }
  };


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <
   class R2>
struct AdaptorRettypeSlot0_
<void,
   R2>
  : public AdaptorSlot_
  {
   typedef void RType;
   typedef Slot0<void> SlotType;
   typedef Slot0<R2> InSlotType;
   typedef AdaptorNode Node;
   typedef CallDataObj2<typename SlotType::Func,Node> CallData;

   static RType callback(void* d)
     {
      CallData* data=(CallData*)d;
      Node* node=data->obj;
      ((typename InSlotType::Callback&)(node->data_))();
     }
   static SlotData* create(SlotData *s)
     {
      SlotData* tmp=(SlotData*)s;
      Node *node=new Node();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.obj=node;
      return tmp;
     }
  };

#endif
#endif


template <class R1,class R2>
Slot0<R1>
  rettype(const Slot0<R2> &s)
  {return AdaptorRettypeSlot0_<R1,R2>::create(s.obj());
  }

/****************************************************************
***** Adaptor Rettype Slot 1
****************************************************************/
template <class R1,
   class P1,
   class R2>
struct AdaptorRettypeSlot1_
  : public AdaptorSlot_
  {
#ifdef SIGC_CXX_PARTIAL_SPEC
   typedef R1 RType;
#else
   typedef typename Trait<R1>::type RType;
#endif
   typedef Slot1<R1,P1> SlotType;
   typedef Slot1<R2,P1> InSlotType;
   typedef AdaptorNode Node;
   typedef CallDataObj2<typename SlotType::Func,Node> CallData;

   static RType callback(void* d,P1 p1)
     {
      CallData* data=(CallData*)d;
      Node* node=data->obj;
      return RType(((typename InSlotType::Callback&)(node->data_))(p1));
     }
   static SlotData* create(SlotData *s)
     {
      SlotData* tmp=(SlotData*)s;
      Node *node=new Node();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.obj=node;
      return tmp;
     }
  };


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <
   class P1,
   class R2>
struct AdaptorRettypeSlot1_
<void,
   P1,
   R2>
  : public AdaptorSlot_
  {
   typedef void RType;
   typedef Slot1<void,P1> SlotType;
   typedef Slot1<R2,P1> InSlotType;
   typedef AdaptorNode Node;
   typedef CallDataObj2<typename SlotType::Func,Node> CallData;

   static RType callback(void* d,P1 p1)
     {
      CallData* data=(CallData*)d;
      Node* node=data->obj;
      ((typename InSlotType::Callback&)(node->data_))(p1);
     }
   static SlotData* create(SlotData *s)
     {
      SlotData* tmp=(SlotData*)s;
      Node *node=new Node();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.obj=node;
      return tmp;
     }
  };

#endif
#endif


template <class R1,class R2,class P1>
Slot1<R1,P1>
  rettype(const Slot1<R2,P1> &s)
  {return AdaptorRettypeSlot1_<R1,
           P1,R2>::create(s.obj());
  }

/****************************************************************
***** Adaptor Rettype Slot 2
****************************************************************/
template <class R1,
   class P1,class P2,
   class R2>
struct AdaptorRettypeSlot2_
  : public AdaptorSlot_
  {
#ifdef SIGC_CXX_PARTIAL_SPEC
   typedef R1 RType;
#else
   typedef typename Trait<R1>::type RType;
#endif
   typedef Slot2<R1,P1,P2> SlotType;
   typedef Slot2<R2,P1,P2> InSlotType;
   typedef AdaptorNode Node;
   typedef CallDataObj2<typename SlotType::Func,Node> CallData;

   static RType callback(void* d,P1 p1,P2 p2)
     {
      CallData* data=(CallData*)d;
      Node* node=data->obj;
      return RType(((typename InSlotType::Callback&)(node->data_))(p1,p2));
     }
   static SlotData* create(SlotData *s)
     {
      SlotData* tmp=(SlotData*)s;
      Node *node=new Node();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.obj=node;
      return tmp;
     }
  };


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <
   class P1,class P2,
   class R2>
struct AdaptorRettypeSlot2_
<void,
   P1,P2,
   R2>
  : public AdaptorSlot_
  {
   typedef void RType;
   typedef Slot2<void,P1,P2> SlotType;
   typedef Slot2<R2,P1,P2> InSlotType;
   typedef AdaptorNode Node;
   typedef CallDataObj2<typename SlotType::Func,Node> CallData;

   static RType callback(void* d,P1 p1,P2 p2)
     {
      CallData* data=(CallData*)d;
      Node* node=data->obj;
      ((typename InSlotType::Callback&)(node->data_))(p1,p2);
     }
   static SlotData* create(SlotData *s)
     {
      SlotData* tmp=(SlotData*)s;
      Node *node=new Node();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.obj=node;
      return tmp;
     }
  };

#endif
#endif


template <class R1,class R2,class P1,class P2>
Slot2<R1,P1,P2>
  rettype(const Slot2<R2,P1,P2> &s)
  {return AdaptorRettypeSlot2_<R1,
           P1,P2,R2>::create(s.obj());
  }

/****************************************************************
***** Adaptor Rettype Slot 3
****************************************************************/
template <class R1,
   class P1,class P2,class P3,
   class R2>
struct AdaptorRettypeSlot3_
  : public AdaptorSlot_
  {
#ifdef SIGC_CXX_PARTIAL_SPEC
   typedef R1 RType;
#else
   typedef typename Trait<R1>::type RType;
#endif
   typedef Slot3<R1,P1,P2,P3> SlotType;
   typedef Slot3<R2,P1,P2,P3> InSlotType;
   typedef AdaptorNode Node;
   typedef CallDataObj2<typename SlotType::Func,Node> CallData;

   static RType callback(void* d,P1 p1,P2 p2,P3 p3)
     {
      CallData* data=(CallData*)d;
      Node* node=data->obj;
      return RType(((typename InSlotType::Callback&)(node->data_))(p1,p2,p3));
     }
   static SlotData* create(SlotData *s)
     {
      SlotData* tmp=(SlotData*)s;
      Node *node=new Node();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.obj=node;
      return tmp;
     }
  };


#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <
   class P1,class P2,class P3,
   class R2>
struct AdaptorRettypeSlot3_
<void,
   P1,P2,P3,
   R2>
  : public AdaptorSlot_
  {
   typedef void RType;
   typedef Slot3<void,P1,P2,P3> SlotType;
   typedef Slot3<R2,P1,P2,P3> InSlotType;
   typedef AdaptorNode Node;
   typedef CallDataObj2<typename SlotType::Func,Node> CallData;

   static RType callback(void* d,P1 p1,P2 p2,P3 p3)
     {
      CallData* data=(CallData*)d;
      Node* node=data->obj;
      ((typename InSlotType::Callback&)(node->data_))(p1,p2,p3);
     }
   static SlotData* create(SlotData *s)
     {
      SlotData* tmp=(SlotData*)s;
      Node *node=new Node();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.obj=node;
      return tmp;
     }
  };

#endif
#endif


template <class R1,class R2,class P1,class P2,class P3>
Slot3<R1,P1,P2,P3>
  rettype(const Slot3<R2,P1,P2,P3> &s)
  {return AdaptorRettypeSlot3_<R1,
           P1,P2,P3,R2>::create(s.obj());
  }


#ifdef SIGC_CXX_NAMESPACES
} // namespace
#endif

#endif
