// -*- C++ -*-
/* This file is part of
 * =================================================
 * 
 *          LyX, The Document Processor
 *          Copyright 1995 Matthias Ettrich.
 *          Copyright 1995-2000 The LyX Team.
 *
 * ================================================= 
 *
 * \author Michael Koziarski
 * \author Baruch Even
 * */

#ifndef GERROR_H
#define GERROR_H

#ifdef __GNUG__
#pragma interface
#endif

#include "ControlError.h"
#include "GnomeBase.h"

namespace Gtk {

class Button;
class Text;

}

/**
 * This class implements the dialog to show error messages.
 */
class GError : public FormCB<ControlError> {
public:
	///
	GError(ControlError & c);
	///
	~GError() {}
	///
	void apply() {}
	///
	void update();
	
private:
	/// Build the dialog
	void build();

	/// Returns true if the dialog input is in a valid state.
	bool validate() const { return true; }

	///
	void CloseClicked() { CancelButton(); }
	
	/// generated by accessors.py
	Gtk::Button * button_close() const;
	/// generated by accessors.py
	Gtk::Text * textarea() const;
};

#endif
